<?php

wp_enqueue_style('inedo-den-all-items');

get_header('main');

?>
    <div id="banner" class="content-container">
        <div class="content">
            <div class="banner-sec">
                <img src="/den/banner-logo-den-w.png" />
            </div>
        </div>
    </div>

    <div class="content-container" id="den-mini-nav">
        <div class="content">
            <ul>
                <li><a href="https://forums.inedo.com/" target="_blank">Community Forums</a></li>
                <li><a href="https://github.com/Inedo">GitHub</a></li>
            </ul>
        </div>
    </div>

<?php

ncms_search_header('Inedo Den', 'Extensions');

?>

    <div id="den-filter-bar" class="content-container">
        <div class="content">
            <div class="tags">
                <h4>Function</h4>
<?php

global $wp_query;

$all_extensions_query = $wp_query->query; // this copies the array in PHP, which is bizarre
$all_extensions_query['nopaging'] = true;
$all_extensions_query['fields'] = 'ids';

$tag_join = '+';
$existing_tags = $wp_query->query_vars['tag_slug__and'];
if (!empty($wp_query->query_vars['tag_slug__in'])) {
    if (count($wp_query->query_vars['tag_slug__in']) > 1) {
        $tag_join = ',';
    }
    $existing_tags = $wp_query->query_vars['tag_slug__in'];
}
$existing_tags = array_values(array_unique($existing_tags));

$all_extensions = get_posts($all_extensions_query);

$all_extension_tags = get_terms(array(
    'taxonomy' => 'post_tag',
    'object_ids' => get_posts(array(
        'post_type' => 'den_extension',
        'nopaging' => true,
        'fields' => 'ids'
    ))
));

$extension_tags = get_terms(array(
    'taxonomy' => 'post_tag',
    'object_ids' => $all_extensions,
    'fields' => 'ids'
));

if (!empty($all_extension_tags)):
?>
                <ul>
<?php foreach ($all_extension_tags as $tag):
    if (!in_array($tag->term_id, $extension_tags)):
?>
                    <li class="disabled"><?php echo esc_html($tag->name); ?></li>
<?php else:
    $url = '/den/all-items';
    $current_tags = $existing_tags;
    $tag_index = array_search($tag->slug, $existing_tags);
    $selected = false;
    if ($tag_index === false) {
        $current_tags[] = $tag->slug;
        sort($current_tags);
    } else {
        $selected = true;
        array_splice($current_tags, $tag_index, 1);
    }

    if (!empty($current_tags)) {
        $url = '/den/tag/' . implode($tag_join, $current_tags);
    }

    if (is_search()) {
        $url = add_query_arg('s', get_search_query(false), $url);
    }
?>
                    <li><a href="<?php echo esc_url($url); ?>"<?php if ($selected) echo ' class="selected"'; ?>><?php echo esc_html($tag->name); ?></a></li>
<?php endif; endforeach; ?>
                </ul>
<?php endif; ?>
            </div>
        </div>
    </div>

    <div class="content-container" id="items">
        <div class="content">
            <div class="row">
<?php

if (!have_posts()):
?>
    <p>No den items found for this filter.</p>
<?php
endif;

while (have_posts()):
    the_post();
?>
    <div <?php post_class('extension-box'); ?>>
        <a href="<?php the_permalink(); ?>">
            <?php the_post_thumbnail(); ?>
            <div class="extension-info">
                <p class="title"><?php the_title(); ?></p>
                <div class="description">
                    <?php the_content(); ?>
                </div>
            </div>
        </a>
    </div>
<?php endwhile; ?>
            </div>
        </div>
    </div>

<?php

the_posts_pagination(array(
    'mid_size' => 2,
    'aria_label' => 'Pages',
    'screen_reader_text' => 'Den item navigation'
));

get_footer('main');
