<?php


wp_enqueue_style('inedo-den-extension-test');

get_header('main');

?>
    <div id="banner" class="content-container">
        <div class="content">
            <div class="button-set left">
                <div class="button">
                    <a href="/den/all-items">&#xab; Back to the Den</a>
                </div>
            </div>
        </div>
    </div>

<?php

while (have_posts()):
    the_post();

?>

    <div id="top-info" class="content-container">
        <div class="content">
            <div <?php post_class('extension-box'); ?>>
                <?php the_post_thumbnail('large'); ?>
                <div class="extension-info">
                    <h2><?php the_title(); ?></h2>
                    <?php the_content(); ?>
                    <div class="extension-links">
                        <ul>
                            <li><a href="https://proget.inedo.com/feeds/Extensions/<?php the_title(); ?>">Releases</a></li>
                            <li><a href="<?php echo esc_url(get_post_meta(get_the_ID(), 'ncms_docs_url', true)); ?>">View Documentation</a></li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div style="clear:both"></div>

    <div id="main-info" class="content-container no-sidebar">
        <div class="content">
            <h3>Installation</h3>
            <h4>Default Extension Installation</h4>
            <div class="attention analogy">
                <img src="/resources/images/icons/analogy.png" />
                <p>
                    If your product installation can access the internet <i>(specifically the
                        <code>https://inedo.com/den/feed</code> URL)</i>,
                    simply navigate to the <b>Admin &gt; Extensions</b> page to browse and install the latest available
                    extension versions.
                </p>
            </div>
            <h4>Offline or Previous Version Extension Installation</h4>
            <p>
                For installations that are restricted from accessing the internet, or if you with to install a version other
                than the latest, extensions can also be installed manually:
            </p>
            <ol>
                <li>
                    Download the desired version of the extension from the <a href="https://proget.inedo.com/feeds/Extensions/<?php the_title(); ?>">public ProGet feed</a>
                </li>
                <li>
                    Copy the extension file (<code><?php the_title(); ?>.upack</code>) to
                    the extensions path. Visit the Admin &gt; Advanced Settings page within your product instance to
                    determine where
                    extensions are stored by examining the <b>Extensions.ExtensionsPath</b> setting.
                </li>
                <li>
                    Ensure the file is named <i>exactly</i> <code><?php the_title(); ?>.upack</code> in the extensions
                    directory, and that
                    <i>no other files with the same name</i> exist in that directory, even with a different extension. For
                    example, make sure to delete an existing
                    <code><?php the_title(); ?>.inedox</code> file if you are installing <code><?php the_title(); ?>.upack</code>
                </li>
                <li>
                    Restart the product's Windows service: Admin &gt; Service &gt; Stop then Start (e.g.
                    <code>INEDOBMSVC</code>, <code>INEDOPROGETSVC</code>)
                </li>
                <li>
                    Restart the product's Web application, either the IIS application pool or the Integrated Web Server
                    service: Admin &gt; Service &gt; Restart Web App
                </li>
                <li>
                    Verify that the new extension has been loaded (Admin &gt; Extensions)
                </li>
            </ol>

            <h3>Pre-Releases</h3>
            <p>
                To access pre-release versions of this extension, you can configure your product installation
                to use Inedo's <a href="https://proget.inedo.com">public ProGet instance</a> to download extension packages.
            </p>
            <p>
                To configure your product installation to point to the pre-release feed, visit the Admin &gt; Advanced
                Settings page
                within the product installation and set the <b>Extensions.UpdateFeedUrl</b> value to:
            </p>
            <p style="background-color: #f2f2f2; padding: 10px;">
                <code>https://proget.inedo.com/upack/Extensions/</code>
            </p>

            <div class="attention best-practice">
                <img src="/resources/images/icons/best-practices.png" />
                <p>
                    This feed has a connector configured to the default URL (i.e. <code>https://inedo.com/den/feed</code>),
                    so
                    if there are no pre-release versions, the latest will always be available.
                </p>
            </div>
        </div>
    </div>
<?php

endwhile;

get_footer('main');
